#!/usr/bin/env bash

APPLICATION_PID=$(ps auxww | grep start.jar | grep -v grep | awk '{print $2}' | sort -r)
APPLICATION_NAME=$(ps -o args= $PPID | awk -F ' ' '{print $NF}' |  awk -F'/' '{print $4}')
HOST_NAME=$(hostname -f)
MONITORING_HOST="{{ coremedia_monitoring_host }}"

GRAFANA_URL="http://${MONITORING_HOST}/grafana/api/annotations/graphite"
GRAFANA_AUTH="{{ coremedia_monitoring_auth }}"
LOG_DIRECTORY=/var/log

NOW=$(date +"%F_%H-M-%S")

if [ ! -z "${MONITORING_HOST}" ]
then
  read -d '' payload << EOF
  {
    "what": "OOM killer for ${APPLICATION_NAME}",
    "tags": [ "oom", "${APPLICATION_NAME}", "${HOST_NAME}" ],
    "data": "out-of-memory exception for ${APPLICATION_NAME}"
  }
  EOF

  # POST /api/annotations/graphite HTTP/1.1
  # Accept: application/json
  # Content-Type: application/json
  #
  # {
  #   "what": "Event - deploy",
  #   "tags": ["deploy", "production"],
  #   "when": 1467844481,
  #   "data": "deploy of master branch happened at Wed Jul 6 22:34:41 UTC 2016"
  # }

  statusCode=$(curl \
    --user ${GRAFANA_AUTH} \
    --write-out %{http_code} \
    --silent \
    --output /dev/null \
    --request POST \
    --header 'Content-type: application/json' \
    --data "${payload}" ${GRAFANA_URL})

fi

(
echo "Running OOM killer script for process ${APPLICATION_NAME} - PID ${APPLICATION_PID} "
kill -9 ${APPLICATION_PID}
echo "Killed process ${APPLICATION_PID}"
) | tee ${LOG_DIRECTORY}/${APPLICATION_NAME}-oom_killer-${NOW}.log
